'1204gewitter.bas fr pong mit Bascom-demo-2.0.7.1, ca.1,2kB von Heinz D.
'
'Kollektor an D2 (Mnzkontakt)
'optional Taste an D3 (Anzeige kurz aktivieren)
'
'die Anzeige erfolgt logarithmisch und steht auf dem Kopf !!!
'
'Die Anzeige steht auf dem Kopf !!!
'-------------------------------------------------------------
$crystal = 8000000                                          'keine Fuse verndert
$regfile = "m8def.dat"
'-------------------------------------------------------------
Dim Pongfeld(12) As Word                                    'Feld
Dim Pongspal As Byte                                        'Spaltenzhler
Dim Pongcout As Byte                                        'temp
Dim Pongdout As Byte                                        'temp

Config Portb = 31                                           '&b00011111
Config Portc = 15                                           '&b00001111
Config Portd = 240                                          '&b11110000

Config Timer2 = Timer , Prescale = 32 :                     '32 bestimmt auch Anzeige+Balkenzeit
On Ovf2 T2interrupt                                         'timer2=anzeige
Enable Timer2 :
Start Timer2 :
Enable Interrupts
'-------------------------------------------------------------
Portd.2 = 1                                                 'pullup Kollektor
Portd.3 = 1                                                 'pullup taste

Dim Pong_led As Bit                                         '0=aus, 1=ein
Dim Anzeigezeit As Word
Dim Anzeige As Word
Anzeige = 4000                                              'ca.4s

Dim Balkenzeit As Word                                      '65536=ca.67s

'=============================================================
'In der Loop wir nur auf D2+D3 reagiert
'=============================================================
Do
'   If Pind.2 = 0 Then                                       'Blitzimpuls 0=aktiv=CD2003
   If Pind.2 = 1 Then                                       'Blitzimpuls 1=aktiv=TA7642
      Pong_led = 1                                          'LED ein
      Anzeigezeit = Anzeige
      Incr Pongfeld(1)                                      'Balken erhhen
      If Pongfeld(1) > 1023 Then Pongfeld(1) = 1023         'max.erreicht
   End If

   If Pind.3 = 0 Then                                       'Taste gedrckt ?
      Pong_led = 1                                          'LED ein
      Anzeigezeit = Anzeige
   End If

Waitms 33                                                   'max.30 Impulse/s
Loop
'====================================================================
'Timer2 bestimmt auch Anzeigezeit + Balkenzeit, daher Prescale=32 !!!
'Die Routine wird alle 1,024ms aktiv = 81 Bilder/s
'====================================================================
T2interrupt:
Decr Anzeigezeit
   If Anzeigezeit = 0 Then                                  'Zeit abgelaufen ?
      Pong_led = 0                                          'LED aus
      Anzeigezeit = 1                                       'aus belassen
   End If

Decr Balkenzeit                                             '65536=ca.67s
   If Balkenzeit = 0 Then                                   'Zeit abgelaufen ?
      Pong_led = 1                                          'LED ein
      Anzeigezeit = Anzeige
'
      Pongfeld(12) = Pongfeld(12) * 3                       'Summen-Balken berechnen
      Pongfeld(12) = Pongfeld(12) + Pongfeld(11)            '11.Balken dazu
      Pongfeld(12) = Pongfeld(12) / 4                       'egalisieren

      Pongfeld(11) = Pongfeld(10)                           'alle Balken eins rauf
      Pongfeld(10) = Pongfeld(9)
      Pongfeld(9) = Pongfeld(8)                             'ich weiss,
      Pongfeld(8) = Pongfeld(7)                             'das geht auch anders,
      Pongfeld(7) = Pongfeld(6)                             'aber nicht schneller !
      Pongfeld(6) = Pongfeld(5)
      Pongfeld(5) = Pongfeld(4)
      Pongfeld(4) = Pongfeld(3)
      Pongfeld(3) = Pongfeld(2)
      Pongfeld(2) = Pongfeld(1)
      Pongfeld(1) = 0                                       '1.Balken lschen
   End If
'------------------------------------------------------------
Portb = Portb And &B11111100                                'alle LED lschen,
Portc = Portc And &B11110000                                'ohne andere Port
Portd = Portd And &B00001111                                'zu beeinflussen

If Pong_led = 0 Then Goto T2i_end                           'LED aus ?
'immer eine Spalte anzeigen =================================
Incr Pongspal                                               'Feld anzeigen
If Pongspal = 13 Then                                       'Spalte 1 ?
   Pongspal = 1
   Portb.4 = 0                                              '4094 data
Else                                                        'Spalte 2-12 ?
   Portb.4 = 1                                              '4094 data
End If
Portb.3 = 1 : Portb.3 = 0                                   '4094 clk
Portb.2 = 1                                                 '4094 strobe

Pongcout = High(pongfeld(pongspal)) And &B00000011          'vorbereiten
Portb = Portb Or Pongcout                                   'anzeigen

Pongdout = Low(pongfeld(pongspal))                          'vorbereiten
Pongcout = Pongdout And &B00001111
Portc = Portc Or Pongcout                                   'anzeigen

Pongdout = Pongdout And &B11110000                          'vorbereiten
Portd = Portd Or Pongdout                                   'anzeigen

T2i_end:
Return
End
